/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	kumoriv1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKukuDeployments implements KukuDeploymentInterface
type FakeKukuDeployments struct {
	Fake *FakeKumoriV1
	ns   string
}

var kukudeploymentsResource = schema.GroupVersionResource{Group: "kumori.systems", Version: "v1", Resource: "kukudeployments"}

var kukudeploymentsKind = schema.GroupVersionKind{Group: "kumori.systems", Version: "v1", Kind: "KukuDeployment"}

// Get takes name of the kukuDeployment, and returns the corresponding kukuDeployment object, and an error if there is any.
func (c *FakeKukuDeployments) Get(name string, options v1.GetOptions) (result *kumoriv1.KukuDeployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kukudeploymentsResource, c.ns, name), &kumoriv1.KukuDeployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuDeployment), err
}

// List takes label and field selectors, and returns the list of KukuDeployments that match those selectors.
func (c *FakeKukuDeployments) List(opts v1.ListOptions) (result *kumoriv1.KukuDeploymentList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kukudeploymentsResource, kukudeploymentsKind, c.ns, opts), &kumoriv1.KukuDeploymentList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kumoriv1.KukuDeploymentList{ListMeta: obj.(*kumoriv1.KukuDeploymentList).ListMeta}
	for _, item := range obj.(*kumoriv1.KukuDeploymentList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kukuDeployments.
func (c *FakeKukuDeployments) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kukudeploymentsResource, c.ns, opts))

}

// Create takes the representation of a kukuDeployment and creates it.  Returns the server's representation of the kukuDeployment, and an error, if there is any.
func (c *FakeKukuDeployments) Create(kukuDeployment *kumoriv1.KukuDeployment) (result *kumoriv1.KukuDeployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kukudeploymentsResource, c.ns, kukuDeployment), &kumoriv1.KukuDeployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuDeployment), err
}

// Update takes the representation of a kukuDeployment and updates it. Returns the server's representation of the kukuDeployment, and an error, if there is any.
func (c *FakeKukuDeployments) Update(kukuDeployment *kumoriv1.KukuDeployment) (result *kumoriv1.KukuDeployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kukudeploymentsResource, c.ns, kukuDeployment), &kumoriv1.KukuDeployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuDeployment), err
}

// Delete takes name of the kukuDeployment and deletes it. Returns an error if one occurs.
func (c *FakeKukuDeployments) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(kukudeploymentsResource, c.ns, name), &kumoriv1.KukuDeployment{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKukuDeployments) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kukudeploymentsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &kumoriv1.KukuDeploymentList{})
	return err
}

// Patch applies the patch and returns the patched kukuDeployment.
func (c *FakeKukuDeployments) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *kumoriv1.KukuDeployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kukudeploymentsResource, c.ns, name, pt, data, subresources...), &kumoriv1.KukuDeployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuDeployment), err
}
